//
// Client.cpp
//
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>
#include <stdio.h>

int main()
{
    int         sockfd;
    int         len;
    struct sockaddr address;
    int         result;
    char        ch       = 'A';
    char buf[128];
    sockfd = socket(AF_UNIX, SOCK_STREAM, 0);

    address.sa_family = AF_UNIX;
    strcpy(address.sa_data, "server_socket");
    len = sizeof(address);

    result = connect(sockfd, (struct sockaddr*)&address, len);

    if(result == -1)
    {
        perror("oops:  client1");
        exit(1);
    }

    int shouldQuit=0;
    do 
    {
   	len=read(STDIN_FILENO, buf, 128);
	//here because the "command line we read the 0xA as return character and 
	//we want to replace the return character with '\0';
	//this simple thing wasted me a lot of time!
	buf[len-1]='\0';
	if (strcmp(buf, "end")==0)
	{
		shouldQuit=1;
	}

	write(sockfd, buf, strlen(buf)+1);
	len=read(sockfd, buf, 128);
	if (len<0)
	{
		printf("read error\n");
		exit(3);
	}
	printf("server replies: %s", buf);
    }
    while (!shouldQuit);
    close(sockfd);
}
