//
// Server.cpp
//
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

extern int errno;
int main()
{
    int         server_sockfd;
    int         client_sockfd;
    int         server_len;
    int         client_len=sizeof(struct sockaddr);
    struct sockaddr server_address;
    struct sockaddr client_address;
    char buf[128];

    unlink("server_socket");
    server_sockfd = socket(AF_UNIX, SOCK_STREAM, 0);
    if (server_sockfd<0)
    {
       	printf("socket error\n");
	exit(2);
    }
    server_address.sa_family = AF_UNIX;
    strcpy(server_address.sa_data, "server_socket");
    server_len = sizeof(server_address);
    bind(server_sockfd, (struct sockaddr*)&server_address, server_len);

    listen(server_sockfd, 5);
    int shouldQuit=0;

    client_sockfd = accept(server_sockfd,(struct sockaddr*)&client_address, &client_len);
    if (client_sockfd<0)
    {
	printf("bad accept: %s\n", strerror(errno));
	exit(9);
    }

    do
    {
	int len=read(client_sockfd, buf, 128);
	if (len<0)
	{
		printf("read error: %d\n", errno);
		exit(1);
	}
	printf("client says:%s\n", buf);
 	if (strcmp("end", buf)==0)
	{
		shouldQuit=1;
	}
	strcat(buf, "server nods his head\n");
        write(client_sockfd, buf, strlen(buf)+1);
    }
    while (!shouldQuit);
    close(server_sockfd);
    
}

